CREATE FUNCTION "dba"."getid_tm_files"()
returns integer
begin
  declare li_return integer;
  select max("id") + 1 into li_return from tm_files;
  if li_return is null or li_return < 1 then
    set li_return=1;
    while exists(select 1 from tm_files where "id" = li_return) loop
      set li_return=li_return+1
    end loop
  end if;
  return(li_return)
end